import java.awt.*;

//Subklasse von Canvas, welche etwas in den Canvas zeichnet
class DameCanvas extends Canvas {
	Dame dame;
	final static int legendSize = 2; /* in ysize units */
	
	public DameCanvas(Dame dame) {
		super();
		this.dame = dame;
	}
	
    public void paint(Graphics g) {
        int w = getSize().width;
        int h = getSize().height;
		
		/* zeichne Schachbrett */
		int xoff = 5, yoff = 5;
		int xsize = (w - 2*xoff) / dame.n;
		int ysize = (h - 2*yoff) / (dame.n+legendSize);
		xoff = (w - dame.n * xsize) / 2;
		yoff = (h - (dame.n+legendSize) * ysize) / 2;
		g.translate(xoff,yoff);
		
		g.setColor(Color.black);
		for (int i = 0; i <= dame.n; i++) {
			g.drawLine(0,i*ysize,dame.n*xsize,i*ysize); // horiz. Linie
			g.drawLine(i*xsize,0,i*xsize,dame.n*ysize); // vert. Linie
		}
		
		g.setColor(Color.green);
		for (int y = 0; y < dame.n; y++) {
			for (int x = 0; x < dame.n; x++) {
				if ((x+y) % 2 == 1) {
					// Schachbrettmuster
					g.fillRect(x*xsize + 1, y*ysize + 1, xsize-1, ysize-1);
				}
			}
		}

		// platzierte Damen einzeichnen
		
		g.setFont(new Font("Helvetica", Font.PLAIN, ysize/2));
		for (int spalte = 0; spalte < dame.n; spalte++) {
			if (dame.loesung.dame[spalte] != dame.UNDEF) {
				// graues Feld
				g.setColor(Color.lightGray);
				g.fillRect(spalte*xsize + 5, dame.loesung.dame[spalte]*ysize + 5, xsize-10, ysize-10);

				// Beschrifte mit Schrittzahl
				g.setColor(Color.black);
				String str = "" + spalte;
				int strWidth = g.getFontMetrics().stringWidth(str);
				int xLoc = spalte*xsize+xsize/2-strWidth/2;				
				g.drawString(str, xLoc, dame.loesung.dame[spalte]*ysize+ysize/2+ysize/2/2);
			}
		}		

		drawLegend(g, 0, dame.n, xsize, ysize, xoff);
    }

	public void drawLegend(Graphics g, int x, int y, int xsize, int ysize, int xoff) {
		g.setFont(new Font("Helvetica", Font.PLAIN, ysize/2));
		int deltaY = (int)(3.0/4.0*(double)(ysize));	
		
		/* Farbige Felder zeichnen */
		g.setColor(Color.lightGray);
		g.fillRect(x*xsize + 3, y*ysize + 5 + deltaY, xsize-10, ysize-10);
		
		/* Beschriftung */
		g.setColor(Color.black);
		g.drawString("Dame", (x+1)*xsize+xsize/2, y*ysize+2*deltaY);		
	}
	
    //Ntig, damit Canvas sicher gezeichnet wird
    public Dimension getMinimumSize() {
        return new Dimension(450,510);
    }

    //Ntig, damit Canvas sicher gezeichnet wird
    public Dimension getPreferredSize() {
        return getMinimumSize();
    }
}
