// SimpleDialog.java
// Klasse, die eine Dialogbox darstellt mit einem 
// vorgegebenen Titel, einem Meldungs-Text und einem Button mit vorgegebenem Labeltext.
// Der Dialog schliesst sich bei Klick auf den Button selbstaendig.

import java.awt.*;
import java.awt.event.*;

class SimpleDialog extends Dialog implements ActionListener {
		// Instanzvariblen fuer ok-Button und einem Label als Meldungstext
		private Button ok;
		
		SimpleDialog(Frame owner, String title, boolean isModal, String text, String buttonLabel) {
			// Der Dialog gehoert zum Frame owner (wichtig wegen Fokus)
			// title = Fenstertitel, isModal = true bei modalem Dialog
			// text  = Meldungstext, buttonLabel = Beschriftung des ok-Buttons
			
			//Super-Konstruktor aufrufen
			super(owner,title, isModal);
			setLayout(new BorderLayout());
			
			// GUI-Elemente erzeugen
			ok =  new Button(buttonLabel);

			TextArea textarea = new TextArea(text);
			Dimension d = textarea.getMinimumSize();
			textarea = new TextArea(text, d.width, d.height, TextArea.SCROLLBARS_NONE);
			textarea.setEditable(false);
			
			// GUI-Elemente zum Dialog hinzufuegen
			add(textarea,BorderLayout.CENTER);
			add(ok,BorderLayout.SOUTH);
			
			// Groesse des Dialoges festlegen
			setResizable(false);
			pack();
			
			// Ereignisbehandlung fuer ok-Button installieren
			ok.addActionListener(this);
			
			// Auf Schliessen des Fentsers reagieren
			addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					dispose(); 

				}
			 });
		}
		public void actionPerformed(ActionEvent e) {
			// Ereignisbehandlung: Dialog ausblenden und Ressourcen freigeben 
			// bei Klick auf ok-Button
			if (e.getSource() == ok) {
				dispose();
			}
		}
}
